/* pp_arm.c */

#include <sys/mman.h>
#include <stdio.h>

#include "pp_arm.h"

const struct io io[] = {
    { HW_RX_OUT,      BNK0, 0, 0, 1, 0, 36, "RX_OUT" },
    { HW_RX_SHIFT,    BNK0, 1, 0, 1, 0, 32, "RX_SHIFT" },
    { HW_RX_DATA_O,   BNK0, 2, 0, 1, 0, 24, "RX_DATA_OUT" },
    { HW_RX_DONE,     BNK0, 3, 0, 1, 0, 20, "RX_DONE" },
    { HW_RX_TR,       BNK0, 4, 0, 1, 0, 16, "RX_XRF_REQ" },
    { HW_RX_ERROR,    BNK0, 5, 0, 1, 0,  8, "RX_ERROR" },
    { HW_RX_AC_LO,    BNK0, 6, 0, 1, 0, 38, "DRV_AC" },
    { HW_RX_DMA, 	  BNK1, 0, 1, 0, 0, 40, "RX_DMA_INTF" },
    { HW_RX_12BIT,    BNK1, 1, 0, 0, 0, 28, "RX_12_BIT" },
    { HW_RX_DATA_I,   BNK1, 5, 0, 0, 0, 24, "RX_DATA_IN" },
    { HW_RX_INIT,     BNK1, 3, 0, 0, GPIO_INT_RE, 12, "RX_INIT" },
    { HW_RX_RUN,      BNK1, 4, 0, 0, 0,  4, "RX_RUN" },
    { 0, -1 } // loop checks reference the bank >= 0, -1 is end indicator
};     

static void dump_gpio(void) {
	int offset;
	
	for (offset = 0; offset < 0xc30; offset += 0x10)
		printf("gpio[0x%04x] = 0x%08x\n", offset, gpio[offset >> 2]);
}

int init_hwio(void) {
	map_gpio(&gpio, 0x80018000, 8192);	
	config_gpio(io, gpio);
	// dump_gpio();
	return 0;
}

int test_init() {
	return rx_if_getff(RX_INIT);
}

void test_init2() {

	fprintf(stderr, "test_init2: bank = %d, bit = %d name = %s sel = 0x%04x\n", io[10].bank, io[10].bit, io[10].name, io[10].sel);
	fprintf(stderr, "test_init2: gpio[0x%04x] = 0x%08x\n", GPIO_INTSTAT(1,3)<<2, gpio[GPIO_INTSTAT(1,3)]);
	fprintf(stderr, "test_init2: byte addr = 0x%04x, mask = 0x%08x\n",  GPIO_INTSTAT(1,3)<<2, GPIO_INTSTAT_M(1,3));
}

int test_init3() {
    return 0;
}

int test_init4(int mask, volatile int *gpio) {
    int i;
    int result = 0;

    for (i = 0; i < 12; i++) {
        if (io[i].sel & mask)
            if (gpio[GPIO_INTSTAT(io[i].bank, io[i].bit)] & GPIO_INTSTAT_M(io[i].bank, io[i].bit))
                result |= io[i].sel;
    }
    return result;
}

//int rx_if_get(int mask){return 0;};
//void rx_if_put(int mask, int val){};
//void rx_if_set(int mask){};
//void rx_if_clr(int mask){};

//void rx_if_clrff(int mask) {
//	rx_if_set(mask);
//	rx_if_clr(mask);
//}
